﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using Xamarin.Forms;
using UIKit;
using QuickLook;
using Test.iOS;
using Foundation;

[assembly: Xamarin.Forms.Dependency(typeof(SaveAndView_iOS))]
namespace Test.iOS
{
    public class SaveAndView_iOS : ISaveAndView
    {
        public async Task SaveAndView(string filename, string contentType, MemoryStream stream)
        {
            try
            {
                //Get the root path of iOS device.
                string path = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
                string filePath = Path.Combine(path, filename);

                //Create a file and write the stream into it.
                FileStream fileStream = File.Open(filePath, FileMode.Create);
                stream.Position = 0;
                stream.CopyTo(fileStream);

                fileStream.Flush();
                fileStream.Close();

                //Launch the saved file for viewing in default viewer.
                UIViewController currentController = UIApplication.SharedApplication.KeyWindow.RootViewController;
                while (currentController.PresentedViewController != null)
                    currentController = currentController.PresentedViewController;
                UIView currentView = currentController.View;

                QLPreviewController preview = new QLPreviewController();
                QLPreviewItem item = new QLPreviewItemBundle(filename, filePath);
                preview.DataSource = new PreviewControllerDS(item);

                currentController.PresentViewController(preview, true, null);
            }
            catch (Exception)
            {
            }
        }

        public async Task<bool> SaveImage(string path, ImageSource imageData)
        {
            return await Task.FromResult<bool>(true);
        }
    }
}