﻿using Syncfusion.XlsIO;
using System;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Text;

namespace Test
{
    public static class ReportGenerator
    {
        public static void GenerateReport(IEnumerable<SiteData> dataCollection)
        {
            using (ExcelEngine excelEngine = new ExcelEngine())
            {
                IApplication application = excelEngine.Excel;
                application.DefaultVersion = ExcelVersion.Excel2013;
                Assembly assembly = typeof(App).GetTypeInfo().Assembly;
                Stream inputStream = assembly.GetManifestResourceStream("Test.Resources.TemplateMarker.xlsx");
                IWorkbook workbook = application.Workbooks.Open(inputStream);

                //Create template marker processor for the workbook
                ITemplateMarkersProcessor marker = workbook.CreateTemplateMarkersProcessor();

                //Adding reports collection to marker variables
                //Where the name should match with the input template
                marker.AddVariable("Reports", dataCollection);

                //Applying Markers
                marker.ApplyMarkers();

                //Saving the workbook as stream
                MemoryStream stream = new MemoryStream();
                workbook.SaveAs(stream);

                stream.Position = 0;

                //Save the document as file and view the saved document
                Xamarin.Forms.DependencyService.Get<ISaveAndView>().SaveAndView("Test.xlsx", "application/msexcel", stream);
            }
        }
    }
}
